summaryrefslogtreecommitdiff
path: root/tests/install/install-C
diff options
context:
space:
mode:
authorKamil Dudka <kdudka@redhat.com>2009-02-17 13:16:54 +0100
committerJim Meyering <meyering@redhat.com>2009-02-17 14:12:44 +0100
commitdac5f12c6ed1225bfb8043d9ff7227d29439a955 (patch)
treed736baa51d46a7c6b53fe93aed03acb12c73f27e /tests/install/install-C
parent26d3d090bd08ff36b1f66af8d4b7974c5d5b6a95 (diff)
downloadcoreutils-dac5f12c6ed1225bfb8043d9ff7227d29439a955.tar.xz
install: add --compare (-C) option to install file only when necessary
* src/install.c (have_same_content): New function to compare files content. (extra_mode): New function checking for non-permission bits in mode. (need_copy): New function to check if copy is necessary. (main): Handle new option --compare (-C). (copy_file): Skip file copying if not necessary. (usage): Show new option --compare (-C) in --help. * tests/install/install-C: Basic tests for install --compare (-C). * tests/install/install-C-root: Tests requiring root privileges. * tests/install/install-C-selinux: Tests requiring SELinux. * tests/Makefile.am: Add new tests for install --compare (-C). * doc/coreutils.texi: Document new install option --compare (-C). * NEWS: Mention the change.
Diffstat (limited to 'tests/install/install-C')
-rwxr-xr-xtests/install/install-C94
1 files changed, 94 insertions, 0 deletions
diff --git a/tests/install/install-C b/tests/install/install-C
new file mode 100755
index 000000000..129286d2d
--- /dev/null
+++ b/tests/install/install-C
@@ -0,0 +1,94 @@
+#!/bin/sh
+# Ensure "install -C" works. (basic tests)
+
+# Copyright (C) 2008 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ ginstall --version
+fi
+
+. $srcdir/test-lib.sh
+
+mode1=0644
+mode2=0755
+mode3=1755
+
+fail=0
+
+echo test > a || framework_failure
+echo "\`a' -> \`b'" > out_installed_first
+echo "removed \`b'
+\`a' -> \`b'" > out_installed_second
+> out_empty
+
+# destination file does not exist
+ginstall -Cv -m$mode1 a b > out || fail=1
+compare out out_installed_first || fail=1
+
+# destination file exists
+ginstall -Cv -m$mode1 a b > out || fail=1
+compare out out_empty || fail=1
+
+# destination file exists (long option)
+ginstall -v --compare -m$mode1 a b > out || fail=1
+compare out out_empty || fail=1
+
+# destination file exists but -C is not given
+ginstall -v -m$mode1 a b > out || fail=1
+compare out out_installed_second || fail=1
+
+# option -C ignored if any non-permission mode should be set
+ginstall -Cv -m$mode3 a b > out || fail=1
+compare out out_installed_second || fail=1
+ginstall -Cv -m$mode3 a b > out || fail=1
+compare out out_installed_second || fail=1
+
+# files are not regular files
+ln -s a c || framework_failure
+ln -s b d || framework_failure
+ginstall -Cv -m$mode1 c d > out || fail=1
+echo "removed \`d'
+\`c' -> \`d'" > out_installed_second_cd
+compare out out_installed_second_cd || fail=1
+
+# destination file exists but content differs
+echo test1 > a || framework_failure
+ginstall -Cv -m$mode1 a b > out || fail=1
+compare out out_installed_second || fail=1
+ginstall -Cv -m$mode1 a b > out || fail=1
+compare out out_empty || fail=1
+
+# destination file exists but content differs (same size)
+echo test2 > a || framework_failure
+ginstall -Cv -m$mode1 a b > out || fail=1
+compare out out_installed_second || fail=1
+ginstall -Cv -m$mode1 a b > out || fail=1
+compare out out_empty || fail=1
+
+# destination file exists but mode differs
+ginstall -Cv -m$mode2 a b > out || fail=1
+compare out out_installed_second || fail=1
+ginstall -Cv -m$mode2 a b > out || fail=1
+compare out out_empty || fail=1
+
+# options -C and --preserve-timestamps are mutually exclusive
+ginstall -C --preserve-timestamps a b && fail=1
+
+# options -C and --strip are mutually exclusive
+ginstall -C --strip --strip-program=echo a b && fail=1
+
+Exit $fail